#include "linkedstructure.h"
#include <cmath>
#include <iostream>
#include "link.h"

#define degrees(x) x*180/3.1415926


MatrixXf LinkedStructure::pseudoInverse()
{
	//
	// TODO: compute and return the pseudo inverse of the jacobian matrix
	//

	MatrixXf A;
	return A;
}
 
Vector2f LinkedStructure::ComputeEndEffectorPosition() 
{
	//
    // TODO: compute the global position of the end effector by using the joints configuration (forward kinematics)
	//
	
	Vector2f v;
	return v;
}

MatrixXf LinkedStructure::jacobian()
{
    MatrixXf J = MatrixXf::Zero(2,mList.size());

	//
	// TODO: compute and return the jacobian matrix 
	//

	
    return J;
}



void LinkedStructure::draw()
{
    // Drawing the link structure on the screen
	Matrix3f A;
	A.setIdentity();
	Vector3f v,ef1,ef2;
	v(0)=0.0;
	v(1)=0.0;
	v(2)=1.0;

	for (unsigned int i = 0; i < mList.size(); i++)
    {
		ef1=A*v;
		A=A*mList[i]->GetSE2();
		ef2=A*v;

		mList[i]->mColor.apply();
		glLineWidth(5.0);
		glBegin(GL_LINES);
		glVertex2d(ef1(0),ef1(1));
		glVertex2d(ef2(0),ef2(1));
		glEnd();
		glLineWidth(1.0);
    }


	glColor3f(1.0,1.0,1.0);
	glPointSize(10.0);
	glBegin(GL_POINTS);
	glVertex3d(mTargetPosition(0),mTargetPosition(1),0.0);
	glEnd();
	glPointSize(1.0);
}

void LinkedStructure::update()
{
	if (isTargetResolved())
	{
		return;
	}


	//
	// TODO: Here we calculate the step that we want the end effector to take (it has to be in the direction towards the target, but not too big)
	//

	
}

bool LinkedStructure::isTargetResolved()
{
	// Checks if at the current position of the linked
	// structure the point we are trying to resolve
	// gets resolved, it's the stop condition for the iterative algorithm

	Vector2f p=ComputeEndEffectorPosition();
	if(fabs(p(0) - mTargetPosition(0)) <= 0.5f &&
	   fabs(p(1) - mTargetPosition(1)) <= 0.5f )
	{
		mResolveTarget = false;
		return true;
	}
   
	return false;
}

void LinkedStructure::GenerateTarget()
{
	mTargetPosition(0) = ((rand() % 2 == 0) ? -1 : 1) * (rand() % (int)(120.0*0.7));
	mTargetPosition(1) = ((rand() % 2 == 0) ? -1 : 1) * (rand() % (int)(120.0*0.7));

	mResolveTarget = true;
}
